<?php
/**
 * @package phpDocumentor
 * @subpackage Links
 */

/**
 * linking classes
 * @package phpDocumentor
 * @subpackage Links
 */
class abstractLink
{
    var $path;
    /**
     * phpdoc alias _phpdoc_inc for phpdoc.inc
     */
    var $fileAlias = '';
    /**
     * element type linked to.
     * can only be a documentable element
     */
    var $type = '';
    var $name = '';
    var $package = '';
    var $subpackage = '';

    function addLink($path,$fileAlias,$pagename,$package,$subpackage)
    {
        $this->path = $path;
        $this->fileAlias = $fileAlias;
        $this->name = $pagename;
        $this->package = $package;
        $this->subpackage = $subpackage;
    }
}

class pageLink extends abstractLink
{
    var $type = 'page';
    
}

class functionLink extends abstractLink
{
    var $type = 'function';
}

class defineLink extends abstractLink
{
    var $type = 'define';
}

class globalLink extends abstractLink
{
    var $type = 'global';
}

class classLink extends abstractLink
{
    var $type = 'class';
}

class methodLink extends abstractLink
{
    var $type = 'method';
    var $class = '';
    
    function addLink($class, $path ,$fileAlias,$name,$package,$subpackage)
    {
        $this->class = $class;
        abstractLink::addLink($path, $fileAlias,$name,$package,$subpackage);
    }
}

class varLink extends abstractLink
{
    var $type = 'var';
    var $class = '';

    function addLink($class,$path,$fileAlias,$name,$package,$subpackage)
    {
        $this->class = $class;
        abstractLink::addLink($path,$fileAlias,$name,$package,$subpackage);
    }
}

class tutorialLink extends abstractLink
{
    var $type = 'tutorial';
    var $section = '';
    var $title = false;
    
    function addLink($section,$path,$name,$package,$subpackage,$title = false)
    {
        $this->section = $section;
        $this->title = $title;
        parent::addLink($path,'',$name,$package,$subpackage);
    }
}
?>