<?php

#  PHPDocumentor Clean Up Script
#
#  This script recursively goes through each file
#  in the directory tree named in the $Start variable
#  and changes all tabs to four spaces and formats the
#  docblock indentation according to the JavaDoc standard.
#
#  That last part meaning, this:
#  /**
#  * note
#  */
#
#  Is changed to this:
#  /**
#   * note
#   */


#  Directory to start in.
$Start = './PHPDocumentor';

#  Files to leave alone...
$NoTouch[] = 'example.inc';





set_time_limit(0);

function Recursor($DirName) {
   global $NoTouch, $Files, $Directories;

   $DirNameHandle=opendir($DirName);

   while ($FileName = readdir($DirNameHandle)) {
      switch ($FileName) {
         case '.':
         case '..':
            break;

         default:
            if ( !in_array(strtolower("$DirName/$FileName"), $NoTouch) ) {
               if (is_dir("$DirName/$FileName")) {
                  $Directories[] = "$DirName/$FileName";
                  Recursor("$DirName/$FileName");
               } else {
                  echo "$DirName/$FileName\n";
                  $Data = implode('', file("$DirName/$FileName") );
                  $Data = preg_replace('/\t/', '    ', $Data);

                  #  This is the JavaDoc liner-upper
                  $Data = preg_replace('/^(\s*)\*/m', '\\1 *', $Data);

                  $Data = trim($Data);
                  $File = fopen("$DirName/$FileName", 'w');
                  fputs($File, $Data);
                  fclose($File);
               }
            }
      }
   }
}


Recursor($Start);

echo "\n\n-- Done --\n";

?>