<?php
/**
* PEAR Package.xml file generator
*
* @note This uses phpDocumentor 1.2.0 docblock templates, and will not parse
* properly with phpDocumentor 1.1.0
* @package PEAR
* @author Greg Beaver <cellog@users.sourceforge.net>
* @copyright Copyright 2002, Greg Beaver
* @version 0.1
*/
/**#@+
* phpDocumentor include files.  If you don't have phpDocumentor, go get it!
* Your php life will be changed forever
*/
require_once("../phpDocumentor/common.inc.php");
require_once("../phpDocumentor/Io.inc");
/**#@-*/

/**
* @global string $version
*/
$version = "1.2.0beta2";
/**
* @global string $state
*/
$state = "beta";
/**
* @global string $date
*/
$date = date('Y-m-d');
/**
* @global string $notes
*/
$notes = <<< EOF
The phpDocumentor team would like to announce the release of phpDocumentor
1.2.0 BETA 2.  This is a beta release and may have bugs and may have a different
structure from the final release

The phpDocumentor team would like to announce the release of phpDocumentor
1.2.0 BETA 2.  This is a beta release and may have bugs and may have a different
structure from the final release.  This beta differs from 1.2.0Beta in that it
should work from pear install PhpDocumentor, and has a few bugs fixed and a few
extra features.

phpDocumentor is a JavaDoc-like automatic documentation generator for PHP
written in PHP.  It is the most versatile tool for documenting PHP.

Once again, phpDocumentor brings a great increase in usability with the 1.2
branch.  The addition of a tokenizer-based parser increases parsing speed by
up to 4 times (that's 400% faster) compared to previous versions.  In addition,
scalability has been improved, allowing generation of documents in multiple
output formats with one command.  The usage of config files makes repetitive
parsing tasks straightforward and reduces the chance for error.

The addition of DocBlock templates, extended documentation (tutorials) parsing,
and many other new features make this release the most useful automatic
documentor for any programming language.

The default HTML Converter has been ported to a new Smarty-based converter,
HTMLframesConverter, and all of the old templates have been ported to the new
Smarty-based format.  The HTMLdefaultConverter has been deprecated since its
functionality is redundant.  Due to the time it takes to convert a template to
the new format, the phpDocumentor team extends an offer to do this conversion
for anyone who has a brand new template.  We may also include the template in a
future release, if permission is granted.

Due to interest from PEAR programmers, there is a new beta-quality XML:DocBook
converter with peardoc2 templates.  This converter could also generate other
DocBook formats, if desired, but does not generate indexing for this release.

The PDF Converter has stepped up to beta-quality, is fully templatable, and
has most bugs completely fixed.  The CHM converter has also taken major strides
and is close to beta quality.

As predicted, the Smarty template engine is the primary template engine for
all converters.

For users new to phpDocumentor, phpDocumentor uses an event-driven parser
and intermediary data structures that allow it to perform at a level other
automatic documentors for PHP cannot achieve:
  --parsing any php file, with multiple classes and functions in the same file
  --fully compliant with even the most esoteric php syntax 
  	(\$string = <<< EOF, for example)
  --ability to generate multiple output formats
  --extremely fast parsing
  --error/warnings by line number and file to allow for debugging of
	documentation tags
  --multiple output templates to easily customize the look of generated
	documentation
  --extensive documentation of the package, including a detailed specification
	for tags and the included template engine
  --open source, GPL
  

A full listing of all closed bugs and feature requests can be found in the 
next section of the notes

phpDocumentor 1.2.0BETA2 is not ready for production use documenting any PHP
project, although it is very stable.  Download it and try the most advanced
solution for PHP documentation today to help us find the last persistent bugs.
There are MANY in the new XML DocBook Converter.  Please try it out and find
them so we can begin to fix them.  HTML Converters are both very stable, as is
the Parser.

EOF;

/**
* Physical location on this computer of the package to parse
* @global string $package_directory
*/
$package_directory = 'C:/Web Pages/chiara/phpdoc';
/**
* PEAR-relative install dir, used as attribute for <dir name="/">
* @global string $baseinstalldir
*/
$baseinstalldir = 'PhpDocumentor';
/**
* Comma-separated list of files and directories to ignore
*
* This uses wildcards * and ? to remove extra files/directories that are
* not part of the package or release
* @global string $ignore
*/
$ignore = array('CVS/','package.xml','*.tgz','test.php','.*','*.apf','greg.ini','Beautifier*','xhtmlcss/','templates_c/','pear.php','phpdoc');
/**
* Mapping of file extensions to the role attribute of the <file> tag
*
* '*' is the default role for files with no extension or extensions not shown
* @global array $roles
*/
$roles = array
			(
				'php' => 'php',
				'inc' => 'php',
				'html' => 'doc',
				'*' => 'php',
			);
			
/**
* Mapping of subdirectory names to the role attribute of the <dir> tag
* @global array $dir_roles
*/
$dir_roles = array
				(
					'spec' => 'doc',
					'tests' => 'test',
					'Release-old' => 'doc',
					'user' => 'php',
					'templates' => 'php',
                    'templates_c' => 'php',
				);
			
/**
* Mapping of filenames to roles for files that don't fit the normal
* {@link $roles}
* @global array $exceptions
*/
$exceptions = array
				(
                    'index.html' => 'php',
                    'INSTALL' => 'doc',
					'README' => 'doc',
                    'FAQ' => 'doc',
					'ChangeLog' => 'doc',
					'makedoc.sh' => 'php',
                    'pear_phpdoc' => 'script',
					'Release-1.2.0' => 'doc',
					'Release-1.1.0' => 'doc',
					'Release-1.1.0rc1' => 'doc',
					'Release-1.1.0rc2' => 'doc',
                    'Release-1.2.0beta1' => 'doc'
				);

/******************************************************************************
*       Don't change anything below here unless you're adventuresome          *
*******************************************************************************/

/**
 * Determines whether output is made html-friendly or not
 * @global boolean $webinterface
 */
$webinterface = isset($_SERVER['PATH_TRANSLATED']);
/**
 * @global Io $files
 */
$files = new Io;

$allfiles = $files->dirList($package_directory);
/**#@+
 * Sorting functions for the file list
 * @param string
 * @param string
 */
function sortfiles($a, $b)
{
	return strnatcasecmp($a['file'],$b['file']);
}

function mystrucsort($a, $b)
{
	if (is_numeric($a) && is_string($b)) return 1;
	if (is_numeric($b) && is_string($a)) return -1;
	if (is_numeric($a) && is_numeric($b))
	{
		if ($a > $b) return 1;
		if ($a < $b) return -1;
		if ($a == $b) return 0;
	}
	return strnatcasecmp($a,$b);
}
/**#@-*/

$struc = array();
foreach($allfiles as $file)
{
	if ($files->checkIgnore(basename($file),dirname($file),$ignore, false))
    {
        print 'Ignoring '.$file."<br>\n";
        continue;
    }
	$path = substr(dirname($file),strlen(str_replace('\\','/',realpath($package_directory)))+1);
	if (!$path) $path = '/';
	$file = basename($file);
	$ext = array_pop(explode('.',$file));
	if (strlen($ext) == strlen($file)) $ext = '';
	$struc[$path][] = array('file' => $file,'ext' => $ext);
}
uksort($struc,'strnatcasecmp');
foreach($struc as $key => $ind)
{
	usort($ind,'sortfiles');
	$struc[$key] = $ind;
}
$tempstruc = $struc;
$struc = array('/' => $tempstruc['/']);
$bv = 0;
foreach($tempstruc as $key => $ind)
{
	$save = $key;
	if ($key != '/')
	{
        $struc['/'] = setup_dirs($struc['/'], explode('/',$key), $tempstruc[$key]);
	}
}
uksort($struc['/'],'mystrucsort');
/**
 * Recursively generate the <filelist> section's <dir> and <file> tags
 * @param array the sorted directory structure
 * @param false|string whether the parent directory has a role this should
 * inherit
 * @param integer indentation level
 * @global array directory roles
 * @global array exceptions to standard file roles
 * @global array standard file roles
 * @global string base installation directory
 */
function getDirTag($struc, $role=false, $level = 0)
{
	global $dir_roles, $exceptions, $roles, $baseinstalldir;
	$res = $spaces = '';
	for($i= -4; $i < $level; $i++)
	{
		$spaces .= ' ';
	}
	foreach($struc as $dir => $files)
	{
		if ($dir === '/')
		{
			$my = '   <dir name="/" baseinstalldir="'.$baseinstalldir.'">'."\n";
			$my .= getDirTag($struc[$dir], $role, $level + 1);
			$my .= '   </dir>';
			return $my;
		} else
		{
			if (!isset($files['file']))
			{
				$myrole = '';
				if ($role) $myrole = $role;
				elseif (isset($dir_roles[$dir])) $myrole = ' role="'.$dir_roles[$dir].'"';
				$res .= $spaces.'<dir name="'.$dir.'"'.$myrole.">\n";
				$res .= getDirTag($files,$myrole,$level + 1);
				$res .= $spaces.'</dir>'."\n";
			} else
			{
				$myrole = '';
				if (!$role)
				{
					$myrole = false;
					if (isset($exceptions[$files['file']]))
					{
						$myrole = $exceptions[$files['file']];
					} elseif (isset($roles[$files['ext']]))
					{
						$myrole = $roles[$files['ext']];
					} else $myrole = $roles['*'];
					$myrole = ' role="'.$myrole.'"';
				}
				
				$res .= $spaces.'<file'.$myrole.'>'.$files['file'].'</file>'."\n";
			}
		}
	}
	return $res;
}
$notes = htmlspecialchars($notes);
$res = getDirTag($struc);
$res = 
" <release>
  <version>$version</version>
  <state>$state</state>
  <date>$date</date>
  <notes>
$notes
  </notes>
  <filelist>
$res
  </filelist>
 </release>
";
if ($webinterface)
print nl2br(str_replace(' ','&nbsp;',htmlentities($res)));
else
print $res;
?>